;**********************************************************************
;    Filename:      usbahiru.asm                                           *
;    Date:          2003/12/5                                         *
;    File Version:                                                    *
;**********************************************************************
 
         list      p=16F84             ; list directive to define processor
         #include <p16F84.inc>         ; processor specific variable definitions
         LIST
; P16F84.INC  Standard Header File, Version 2.00    Microchip Technology, Inc.
         LIST
  
         __CONFIG   _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC
 
;***** VARIABLE DEFINITIONS
w_temp        EQU     0x0C        ; variable used for context saving 
status_temp   EQU     0x0D        ; variable used for context saving
 
led_data        EQU     0x11            ;LED set data
                                        ;led_data,0  LED 0
                                        ;led_data,1  LED 1
                                        ;led_data,2  LED 2
wait_data2	EQU	0x12		;wait data2 ram

wait_data       EQU     0x15            ;wait data ram
color_count	EQU	0x16		;color count ram

taihi           EQU     0x18            ;taihi data
led0_count	EQU	0x19		;LED 0 count ram
led1_count      EQU     0x1a            ;LED 1 count ram
led2_count	EQU     0x1b            ;LED 2 count ram
 
led0_on		EQU     0x20            ;LED 0 ON data ram
led0_off	EQU     0x21            ;LED 0 OFF data ram
led1_on		EQU     0x22            ;LED 1 ON data ram
led1_off	EQU     0x23            ;LED 1 OFF data ram
led2_on		EQU     0x24            ;LED 2 ON data ram
led2_off	EQU     0x25            ;LED 2 OFF data ram
 
tm0_setdata     EQU     0f3h            ;FFH-F3H=12 12*16=192usec
;**********************************************************************
                ORG     0x000             ; processor reset vector
                goto    main              ; go to beginning of program
 
                ORG     0x004             ; interrupt vector location
                movwf   w_temp            ; save off current W register contents
                movf    STATUS,w          ; move status register into W register
                movwf   status_temp       ; save off contents of STATUS register
                ;---------------------------------------------------------------
                bcf     INTCON,T0IF
                movlw   tm0_setdata
                movwf   TMR0
                ;---------------------------------

                ;---------------------------------
int_next2
                ;----------------------- LED0
led0_leds	decfsz  led0_count,1
                goto    led1_leds
                btfsc   led_data,0      ;LED0 OFF?
                goto    led0_leds_2
led0_leds_3	bsf     led_data,0      ;LED0 ON
                movf    led0_on,0
                movwf   led0_count
                movf    led0_count,0
                btfsc   STATUS,2
                goto    led0_leds_2
                goto    led1_leds
led0_leds_2	bcf     led_data,0      ;LED0 OFF
                movf    led0_off,0
                movwf   led0_count
                movf    led0_count,0
                btfsc   STATUS,2
                goto    led0_leds_3
                ;----------------------- LED1
led1_leds	decfsz  led1_count,1
                goto    led2_leds
                btfsc   led_data,1      ;LED1 OFF?
                goto    led1_leds_2
led1_leds_3	bsf     led_data,1      ;LED1 ON
                movf    led1_on,0
                movwf   led1_count
                movf    led1_count,0
                btfsc   STATUS,2
                goto    led1_leds_2
                goto    led2_leds
led1_leds_2	bcf     led_data,1      ;LED1 OFF
                movf    led1_off,0
                movwf   led1_count
                movf    led1_count,0
                btfsc   STATUS,2
                goto    led1_leds_3
                ;----------------------- LED2
led2_leds	decfsz  led2_count,1
                goto    led3_leds
                btfsc   led_data,2      ;LED2 OFF?
                goto    led2_leds_2
led2_leds_3	bsf     led_data,2      ;LED2 ON
                movf    led2_on,0
                movwf   led2_count
                movf    led2_count,0
                btfsc   STATUS,2
                goto    led2_leds_2
                goto    led3_leds
led2_leds_2	bcf     led_data,2      ;LED2 OFF
                movf    led2_off,0
                movwf   led2_count
                movf    led2_count,0
                btfsc   STATUS,2
                goto    led2_leds_3
                ;---------------------------------
led3_leds	

next_leds_3
                ;----------------------------------
int_end
                movf    status_temp,w     ; retrieve copy of STATUS register
                movwf   STATUS            ; restore pre-isr STATUS register contents
                swapf   w_temp,f
                swapf   w_temp,w          ; restore pre-isr W register contents
                retfie                    ; return from interrupt
;--------------------------------------------------------------------------
main
                call    port_set
                movlw   0ffh
                movwf   PORTA
                movlw   080h
                movwf   PORTB
 
                call    timer0_set
 
		movlw	00h
		movwf	color_count

main_2
                movlw   00h
                movwf   led_data        ;LED ALL OFF
                call    set_lo_leds
		movf	led0_on,0
		movwf	led0_count
                movf    led1_on,0
                movwf   led1_count
                movf    led2_on,0
                movwf   led2_count

		call	led_set
 
                movlw   080h
                movwf   PORTB

                bsf     INTCON,GIE
                nop
                bsf     INTCON,T0IE
                nop
;--------------------------------------
main_loop

;--------------------------------------
main_key
		btfsc	PORTB,7
		goto	led0_led
		call	wait_1
		call	wait_1
		btfsc	PORTB,7
		goto	led0_led
		call	shift_change
		call	led_set
main_keyp
		call	wait_1
		call	wait_1
		btfss	PORTB,7
		goto	main_keyp
		goto	main_2
;--------------------------------------
led0_led
                btfss   led_data,0
                goto    led0_led_off
                bsf     PORTB,0
                nop
                goto    led1_led
led0_led_off
                bcf     PORTB,0
                nop
;--------------------------------------
led1_led
                btfss   led_data,1
                goto    led1_led_off
                bsf     PORTB,1
                nop
                goto    led2_led
led1_led_off
                bcf     PORTB,1
                nop
;---------------------------------------
led2_led
                btfss   led_data,2
                goto    led2_led_off
                bsf     PORTB,2
                nop
                goto    led3_led
led2_led_off
                bcf     PORTB,2
                nop
;---------------------------------------
led3_led

;--------------------------------------
main_next_3
                goto    main_loop
;-------------------------------------------------------------------------------
wait_1          
                movlw   0ffh
                movwf   wait_data
wait_2
                nop
                decfsz  wait_data,1
                goto    wait_2
                return
;-------------------------------------------------------------------------------
shift_change
		movlw	0fh
		subwf	color_count,0
		btfsc	STATUS,2
		goto	shift_change1
		incf	color_count,1
		return

shift_change1
		movlw	00h
		movwf	color_count
		return

;-------------------------------------------------------------------------------
led_set
	        call    set_on_led0
                movwf   led0_on
                sublw	70h
                movwf   led0_off

	        call    set_on_led1
                movwf   led1_on
                sublw	70h
                movwf   led1_off

	        call    set_on_led2
                movwf   led2_on
                sublw	70h
                movwf   led2_off

		return

;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
set_on_led0
		movf    color_count,0
                movwf   taihi
                movlw   low(led0_on_table)
                addwf   taihi,1
                movlw   high(led0_on_table)
                movwf   PCLATH
                addcf   PCLATH,1
                movf    taihi,0
                movwf   PCL
led0_on_table   
		retlw	70h
		retlw	00h
		retlw	00h
		retlw	70h
		retlw	00h
		retlw	70h
		retlw	70h
		retlw	70h
		retlw	70h
		retlw	20h
		retlw	00h
		retlw	20h
		retlw	00h
		retlw	20h
		retlw	00h
		retlw	20h

set_on_led1
		movf    color_count,0
                movwf   taihi
                movlw   low(led1_on_table)
                addwf   taihi,1
                movlw   high(led1_on_table)
                movwf   PCLATH
                addcf   PCLATH,1
                movf    taihi,0
                movwf   PCL
led1_on_table   
		retlw	00h
		retlw	70h
		retlw	00h
		retlw	70h
		retlw	70h
		retlw	00h
		retlw	70h
		retlw	20h
		retlw	00h
		retlw	70h
		retlw	70h
		retlw	00h
		retlw	20h
		retlw	20h
		retlw	20h
		retlw	00h

set_on_led2
		movf    color_count,0
                movwf   taihi
                movlw   low(led2_on_table)
                addwf   taihi,1
                movlw   high(led2_on_table)
                movwf   PCLATH
                addcf   PCLATH,1
                movf    taihi,0
                movwf   PCL
led2_on_table   
		retlw	00h
		retlw	00h
		retlw	70h
		retlw	00h
		retlw	70h
		retlw	70h
		retlw	70h
		retlw	00h
		retlw	20h
		retlw	00h
		retlw	20h
		retlw	70h
		retlw	70h
		retlw	00h
		retlw	20h
		retlw	20h

;-------------------------------------------------------------------------------
set_lo_leds     movlw   00h
		movwf	led0_on
                movwf   led1_on
                movwf   led2_on
                movlw   70h
		movwf	led0_off
                movwf   led1_off
                movwf   led2_off
                return
;-------------------------------------------------------------------------------
port_set                                ;RA0,RA1,RA2,RA3,RA4(OUT)

                                        ;RB0,RB1,RB2,RB3,RB4,RB5,RB6(OUT)
					;RB7(IN)
                bsf     STATUS,RP0
                clrf    TRISA
		nop
                clrf    TRISB
		bsf	TRISB,7
		nop
                bcf     STATUS,RP0
                return
 
timer0_set
 
                bsf     STATUS,RP0
                movlw   083h            ;(1)PORTB NOT PULLUP
                                        ;(0)INTEDG
                                        ;(0)TOCS
                                        ;(0)TOSE
                                        ;(0)PSA
                                        ;(011)1/16
                movwf   OPTION_REG
                bcf     STATUS,RP0
                 
                movlw   tm0_setdata
                movwf   TMR0
                return
 
 
                END                     ; directive 'end of program'
